/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.5 Revision 1.24
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.5 2006/03/01 12:54:35 dcoutts Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.24 2011/05/08 15:13:10 slyfox Exp $
4# 4#
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 5# Original authors: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 6# Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 7# Maintained by: Haskell herd <haskell@gentoo.org>
8# 8#
16# reflect the tools and features that the package makes 16# reflect the tools and features that the package makes
17# use of. 17# use of.
18# 18#
19# Currently supported features: 19# Currently supported features:
20# haddock -- for documentation generation 20# haddock -- for documentation generation
21# hscolour -- generation of colourised sources
21# alex -- lexer/scanner generator 22# alex -- lexer/scanner generator
22# happy -- parser generator 23# happy -- parser generator
23# c2hs -- C interface generator 24# c2hs -- C interface generator
24# cpphs -- C preprocessor clone written in Haskell 25# cpphs -- C preprocessor clone written in Haskell
25# profile -- if package supports to build profiling-enabled libraries 26# profile -- if package supports to build profiling-enabled libraries
26# bootstrap -- only used for the cabal package itself 27# bootstrap -- only used for the cabal package itself
27# bin -- the package installs binaries 28# bin -- the package installs binaries
28# lib -- the package installs libraries 29# lib -- the package installs libraries
30# nocabaldep -- don't add dependency on cabal.
31# only used for packages that _must_ not pull the dependency
32# on cabal, but still use this eclass (e.g. haskell-updater).
29# 33#
30# Dependencies on other cabal packages have to be specified 34# Dependencies on other cabal packages have to be specified
31# correctly. 35# correctly.
32# 36#
33# Cabal libraries should usually be SLOTted with "${PV}". 37# Cabal libraries should usually be SLOTted with "${PV}".
34# 38#
35# Many Cabal packages require S to be manually set. 39# Many Cabal packages require S to be manually set.
36# 40#
37# Conforming Cabal packages don't require any function definitions 41# Conforming Cabal packages don't require any function definitions
38# in the ebuild. 42# in the ebuild.
43#
44# Special flags to Cabal Configure can now be set by using
45# CABAL_CONFIGURE_FLAGS
39 46
40inherit ghc-package 47inherit ghc-package multilib
41 48
49# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
50# @DESCRIPTION:
51# User-specified additional parameters passed to 'setup configure'.
52# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
53: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
54
55# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
56# @DESCRIPTION:
57# User-specified additional parameters for ghc when building
58# _only_ 'setup' binary bootstrap.
59# example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
60# linking 'setup' faster.
61: ${GHC_BOOTSTRAP_FLAGS:=}
62
63HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
64
65case "${EAPI:-0}" in
66 2|3|4) HASKELL_CABAL_EXPF+=" src_configure" ;;
67 *) ;;
68esac
69
70EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
42 71
43for feature in ${CABAL_FEATURES}; do 72for feature in ${CABAL_FEATURES}; do
44 case ${feature} in 73 case ${feature} in
45 haddock) CABAL_USE_HADDOCK=yes;; 74 haddock) CABAL_USE_HADDOCK=yes;;
75 hscolour) CABAL_USE_HSCOLOUR=yes;;
46 alex) CABAL_USE_ALEX=yes;; 76 alex) CABAL_USE_ALEX=yes;;
47 happy) CABAL_USE_HAPPY=yes;; 77 happy) CABAL_USE_HAPPY=yes;;
48 c2hs) CABAL_USE_C2HS=yes;; 78 c2hs) CABAL_USE_C2HS=yes;;
49 cpphs) CABAL_USE_CPPHS=yes;; 79 cpphs) CABAL_USE_CPPHS=yes;;
50 profile) CABAL_USE_PROFILE=yes;; 80 profile) CABAL_USE_PROFILE=yes;;
51 bootstrap) CABAL_BOOTSTRAP=yes;; 81 bootstrap) CABAL_BOOTSTRAP=yes;;
52 bin) CABAL_HAS_BINARIES=yes;; 82 bin) CABAL_HAS_BINARIES=yes;;
53 lib) CABAL_HAS_LIBRARIES=yes;; 83 lib) CABAL_HAS_LIBRARIES=yes;;
84 nocabaldep) CABAL_FROM_GHC=yes;;
54 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";; 85 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
55 esac 86 esac
56done 87done
57 88
58if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 89if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
59 IUSE="${IUSE} doc" 90 IUSE="${IUSE} doc"
60 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 91 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
61 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock" 92fi
93
94if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
95 IUSE="${IUSE} hscolour"
96 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
62fi 97fi
63 98
64if [[ -n "${CABAL_USE_ALEX}" ]]; then 99if [[ -n "${CABAL_USE_ALEX}" ]]; then
65 DEPEND="${DEPEND} dev-haskell/alex" 100 DEPEND="${DEPEND} dev-haskell/alex"
66 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
67fi 101fi
68 102
69if [[ -n "${CABAL_USE_HAPPY}" ]]; then 103if [[ -n "${CABAL_USE_HAPPY}" ]]; then
70 DEPEND="${DEPEND} dev-haskell/happy" 104 DEPEND="${DEPEND} dev-haskell/happy"
71 cabalconf="${cabalconf} --with-happy=/usr/bin/happy"
72fi 105fi
73 106
74if [[ -n "${CABAL_USE_C2HS}" ]]; then 107if [[ -n "${CABAL_USE_C2HS}" ]]; then
75 DEPEND="${DEPEND} dev-haskell/c2hs" 108 DEPEND="${DEPEND} dev-haskell/c2hs"
76 cabalconf="${cabalconf} --with-c2hs=/usr/bin/c2hs"
77fi 109fi
78 110
79if [[ -n "${CABAL_USE_CPPHS}" ]]; then 111if [[ -n "${CABAL_USE_CPPHS}" ]]; then
80 DEPEND="${DEPEND} dev-haskell/cpphs" 112 DEPEND="${DEPEND} dev-haskell/cpphs"
81 cabalconf="${cabalconf} --with-cpphs=/usr/bin/cpphs"
82fi 113fi
83 114
84if [[ -n "${CABAL_USE_PROFILE}" ]]; then 115if [[ -n "${CABAL_USE_PROFILE}" ]]; then
85 IUSE="${IUSE} profile" 116 IUSE="${IUSE} profile"
86fi 117fi
87 118
88# We always use a standalone version of Cabal, rather than the one that comes 119# We always use a standalone version of Cabal, rather than the one that comes
89# with GHC. But of course we can't depend on cabal when building cabal itself. 120# with GHC. But of course we can't depend on cabal when building cabal itself.
90if [[ -z "${CABAL_BOOTSTRAP}" ]]; then 121if [[ -z ${CABAL_MIN_VERSION} ]]; then
122 CABAL_MIN_VERSION=1.1.4
123fi
124if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
91 DEPEND="${DEPEND} >=dev-haskell/cabal-1.1.3" 125 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
92fi 126fi
93 127
94# Libraries require GHC to be installed. 128# Libraries require GHC to be installed.
95if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then 129if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
96 RDEPEND="${RDEPEND} virtual/ghc" 130 RDEPEND="${RDEPEND} dev-lang/ghc"
131fi
132
133# returns the version of cabal currently in use
134_CABAL_VERSION_CACHE=""
135cabal-version() {
136 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
137 if [[ "${CABAL_BOOTSTRAP}" ]]; then
138 # We're bootstrapping cabal, so the cabal version is the version
139 # of this package itself.
140 _CABAL_VERSION_CACHE="${PV}"
141 elif [[ "${CABAL_FROM_GHC}" ]]; then
142 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
143 # /path/to/ghc/Cabal-${VER} -> ${VER}
144 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
145 else
146 # We ask portage, not ghc, so that we only pick up
147 # portage-installed cabal versions.
148 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
149 fi
97fi 150 fi
151 echo "${_CABAL_VERSION_CACHE}"
152}
98 153
99cabal-bootstrap() { 154cabal-bootstrap() {
100 local setupmodule 155 local setupmodule
101 local cabalversion 156 local cabalpackage
102 if [[ -f "${S}/Setup.lhs" ]]; then 157 if [[ -f "${S}/Setup.lhs" ]]; then
103 setupmodule="${S}/Setup.lhs" 158 setupmodule="${S}/Setup.lhs"
104 else 159 else
105 if [[ -f "${S}/Setup.hs" ]]; then 160 if [[ -f "${S}/Setup.hs" ]]; then
106 setupmodule="${S}/Setup.hs" 161 setupmodule="${S}/Setup.hs"
109 fi 164 fi
110 fi 165 fi
111 166
112 # We build the setup program using the latest version of 167 # We build the setup program using the latest version of
113 # cabal that we have installed 168 # cabal that we have installed
114 cabalversion=$(ghc-bestcabalversion) 169 if version_is_at_least "6.4" "$(ghc-version)"; then
170 cabalpackage=Cabal-$(cabal-version)
171 else
172 # older ghc's don't support package versioning
173 cabalpackage=Cabal
174 fi
115 einfo "Using ${cabalversion}." 175 einfo "Using cabal-$(cabal-version)."
176
177 make_setup() {
116 $(ghc-getghc) -package "${cabalversion}" --make "${setupmodule}" -o setup \ 178 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" \
179 ${GHC_BOOTSTRAP_FLAGS} \
180 "$@" \
181 -o setup
182 }
183 if $(ghc-supports-shared-libraries); then
184 # some custom build systems might use external libraries,
185 # for which we don't have shared libs, so keep static fallback
186 make_setup -dynamic "$@" || make_setup "$@" || die "compiling ${setupmodule} failed"
187 else
117 || die "compiling ${setupmodule} failed" 188 make_setup "$@" || die "compiling ${setupmodule} failed"
189 fi
190}
191
192cabal-mksetup() {
193 local setupdir
194
195 if [[ -n $1 ]]; then
196 setupdir=$1
197 else
198 setupdir=${S}
199 fi
200
201 rm -f "${setupdir}"/Setup.{lhs,hs}
202
203 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
204 > $setupdir/Setup.hs
205}
206
207cabal-hscolour() {
208 ./setup hscolour || die "setup hscolour failed"
118} 209}
119 210
120cabal-haddock() { 211cabal-haddock() {
121 ./setup haddock || die "setup haddock failed" 212 ./setup haddock || die "setup haddock failed"
122} 213}
123 214
215cabal-hscolour-haddock() {
216 # --hyperlink-source implies calling 'setup hscolour'
217 ./setup haddock --hyperlink-source || die "setup haddock failed"
218}
219
124cabal-configure() { 220cabal-configure() {
221 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
222
223 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
224 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
225 fi
125 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 226 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
126 cabalconf="${cabalconf} --enable-executable-profiling";
127 cabalconf="${cabalconf} --enable-library-profiling" 227 cabalconf="${cabalconf} --enable-library-profiling"
128 fi 228 fi
129 # Don't build GHCi libs for arches that do not support GHCi. 229 if [[ -n "${CABAL_USE_ALEX}" ]]; then
230 cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
231 fi
232
233 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
234 cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
235 fi
236
237 if [[ -n "${CABAL_USE_C2HS}" ]]; then
238 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
239 fi
240 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
241 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
242 fi
243
130 # Also building GHCi libs on ppc64 causes "TOC overflow". 244 # Building GHCi libs on ppc64 causes "TOC overflow".
131 if use alpha || use ppc64; then 245 if use ppc64; then
132 cabalconf="${cabalconf} --disable-library-for-ghci" 246 cabalconf="${cabalconf} --disable-library-for-ghci"
133 fi 247 fi
134 248
249 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
250 # so translate LDFLAGS to ghc parameters (without filtering)
251 local flag
252 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
253
254 if version_is_at_least "1.4" "$(cabal-version)"; then
255 # disable executable stripping for the executables, as portage will
256 # strip by itself, and pre-stripping gives a QA warning.
257 # cabal versions previous to 1.4 does not strip executables, and does
258 # not accept the flag.
259 # this fixes numerous bugs, amongst them;
260 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
261 cabalconf="${cabalconf} --disable-executable-stripping"
262 fi
263
264 if version_is_at_least "1.2.0" "$(cabal-version)"; then
265 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
266 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
267 # it's better if the configure chatter is in the build logs:
268 cabalconf="${cabalconf} --verbose"
269 fi
270 # Note: with Cabal-1.1.6.x we do not have enough control
271 # to put the docs into the right place. They're currently going
272 # into /usr/share/${P}/ghc-x.y/doc/
273 # rather than /usr/share/doc/${PF}/
274 # Because we can only set the datadir, not the docdir.
275
276 # We build shared version of our Cabal where ghc ships it's shared
277 # version of it. We will link ./setup as dynamic binary againt Cabal later.
278 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
279 $(ghc-supports-shared-libraries) && \
280 cabalconf="${cabalconf} --enable-shared"
281
135 ./setup configure \ 282 ./setup configure \
136 --ghc --prefix=/usr \ 283 --ghc --prefix="${EPREFIX}"/usr \
137 --with-compiler="$(ghc-getghc)" \ 284 --with-compiler="$(ghc-getghc)" \
138 --with-hc-pkg="$(ghc-getghcpkg)" \ 285 --with-hc-pkg="$(ghc-getghcpkg)" \
286 --prefix="${EPREFIX}"/usr \
287 --libdir="${EPREFIX}"/usr/$(get_libdir) \
288 --libsubdir=${P}/ghc-$(ghc-version) \
289 --datadir="${EPREFIX}"/usr/share/ \
290 --datasubdir=${P}/ghc-$(ghc-version) \
139 ${cabalconf} \ 291 ${cabalconf} \
292 ${CABAL_CONFIGURE_FLAGS} \
293 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
140 "$@" || die "setup configure failed" 294 "$@" || die "setup configure failed"
141} 295}
142 296
143cabal-build() { 297cabal-build() {
298 unset LANG LC_ALL LC_MESSAGES
144 ./setup build \ 299 ./setup build \
145 || die "setup build failed" 300 || die "setup build failed"
146} 301}
147 302
148cabal-copy() { 303cabal-copy() {
304 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
305
149 ./setup copy \ 306 ./setup copy \
150 --copy-prefix="${D}/usr" \ 307 --destdir="${D}" \
151 || die "setup copy failed" 308 || die "setup copy failed"
152 309
153 # cabal is a bit eager about creating dirs, 310 # cabal is a bit eager about creating dirs,
154 # so remove them if they are empty 311 # so remove them if they are empty
155 rmdir "${D}/usr/bin" 2> /dev/null 312 rmdir "${ED}/usr/bin" 2> /dev/null
156 313
157 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has 314 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
158 # no workaround. 315 # no workaround.
159 # set the +x permission on executables 316 # set the +x permission on executables
160 if [[ -d "${D}/usr/bin" ]] ; then 317 if [[ -d "${ED}/usr/bin" ]] ; then
161 chmod +x "${D}/usr/bin/"* 318 chmod +x "${ED}/usr/bin/"*
162 fi 319 fi
320 # TODO: do we still need this?
163} 321}
164 322
165cabal-pkg() { 323cabal-pkg() {
166 # This does not actually register since we're using /usr/bin/true instead 324 # This does not actually register since we're using true instead
167 # of ghc-pkg. So it just leaves the .installed-pkg-config and we can 325 # of ghc-pkg. So it just leaves the .installed-pkg-config and we can
168 # register that ourselves (if it exists). 326 # register that ourselves (if it exists).
169 local result 327 local result
170 local err 328 local err
171 329
172 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then 330 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
173 sed -i 's:ghc-pkg:/usr/bin/true:' .setup-config 331 if version_is_at_least "1.2.0" "$(cabal-version)"; then
174 ./setup register || die "setup register failed" 332 # Newer cabal can generate a package conf for us:
175 if [[ -f .installed-pkg-config ]]; then 333 ./setup register --gen-pkg-config="${T}/${P}.conf"
176 ghc-setup-pkg .installed-pkg-config 334 ghc-setup-pkg "${T}/${P}.conf"
177 ghc-install-pkg 335 ghc-install-pkg
178 else 336 else
337 # With older cabal we have to hack it by replacing its ghc-pkg
338 # with true and then just picking up the .installed-pkg-config
339 # file and registering that ourselves (if it exists).
340 sed -i "s|$(ghc-getghcpkg)|$(type -P true)|" .setup-config
341 ./setup register || die "setup register failed"
342 if [[ -f .installed-pkg-config ]]; then
343 ghc-setup-pkg .installed-pkg-config
344 ghc-install-pkg
345 else
179 die "setup register has not generated a package configuration file" 346 die "setup register has not generated a package configuration file"
347 fi
180 fi 348 fi
181 fi 349 fi
350}
351
352# Some cabal libs are bundled along with some versions of ghc
353# eg filepath-1.0 comes with ghc-6.6.1
354# by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
355# when building with this version of ghc, the ebuild is a dummy that is it will
356# install no files since the package is already included with ghc.
357# However portage still records the dependency and we can upgrade the package
358# to a later one that's not included with ghc.
359# You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
360cabal-is-dummy-lib() {
361 for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
362 [[ "$(ghc-version)" == "$version" ]] && return 0
363 done
364 return 1
182} 365}
183 366
184# exported function: check if cabal is correctly installed for 367# exported function: check if cabal is correctly installed for
185# the currently active ghc (we cannot guarantee this with portage) 368# the currently active ghc (we cannot guarantee this with portage)
186haskell-cabal_pkg_setup() { 369haskell-cabal_pkg_setup() {
187 if [[ -z "${CABAL_BOOTSTRAP}" ]] && ! ghc-sanecabal "1.1.3"; then 370 ghc-package_pkg_setup
371 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
188 eerror "The package dev-haskell/cabal is not correctly installed for" 372 eerror "The package dev-haskell/cabal is not correctly installed for"
189 eerror "the currently active version of ghc ($(ghc-version)). Please" 373 eerror "the currently active version of ghc ($(ghc-version)). Please"
190 eerror "run ghc-updater or re-emerge dev-haskell/cabal." 374 eerror "run ghc-updater or haskell-updater or re-build dev-haskell/cabal."
191 die "cabal is not correctly installed" 375 die "cabal is not correctly installed"
192 fi 376 fi
193 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then 377 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
194 eerror "QA: Neither bin nor lib are in CABAL_FEATURES." 378 eerror "QA: Neither bin nor lib are in CABAL_FEATURES."
195 fi 379 fi
196 if [[ -n "${CABAL_UNKNOWN}" ]]; then 380 if [[ -n "${CABAL_UNKNOWN}" ]]; then
197 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNONW}" 381 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
198 fi 382 fi
383 if cabal-is-dummy-lib; then
384 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
385 fi
386}
387
388haskell-cabal_src_configure() {
389 if ! cabal-is-dummy-lib; then
390 pushd "${S}" > /dev/null
391
392 cabal-bootstrap
393
394 cabal-configure $ghc_flags "$@"
395
396 popd > /dev/null
397 fi
398}
399
400# exported function: nice alias
401cabal_src_configure() {
402 haskell-cabal_src_configure "$@"
199} 403}
200 404
201# exported function: cabal-style bootstrap configure and compile 405# exported function: cabal-style bootstrap configure and compile
202cabal_src_compile() { 406cabal_src_compile() {
203 cabal-bootstrap 407 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
204 cabal-configure 408 # and forgets to separate src_compile() to src_configure()/src_compile().
409 # Such error leads to default src_configure and we lose all passed flags.
410 if ! has "${EAPI:-0}" 0 1; then
411 local passed_flag
412 for passed_flag in "$@"; do
413 [[ ${passed_flag} == --flags=* ]] && \
414 eqawarn "Cabal option '${passed_flag}' has effect only in src_configure()"
415 done
416 fi
417
418 if ! cabal-is-dummy-lib; then
419 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
205 cabal-build 420 cabal-build
206 421
207 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 422 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
423 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
424 # hscolour and haddock
425 cabal-hscolour-haddock
426 else
427 # just haddock
208 cabal-haddock 428 cabal-haddock
429 fi
430 else
431 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
432 # just hscolour
433 cabal-hscolour
434 fi
209 fi 435 fi
436 fi
210} 437}
438
211haskell-cabal_src_compile() { 439haskell-cabal_src_compile() {
440 pushd "${S}" > /dev/null
441
212 cabal_src_compile 442 cabal_src_compile "$@"
443
444 popd > /dev/null
445}
446
447haskell-cabal_src_test() {
448 pushd "${S}" > /dev/null
449
450 if cabal-is-dummy-lib; then
451 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
452 else
453 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
454 ./setup test || die "cabal test failed"
455 fi
456
457 popd > /dev/null
213} 458}
214 459
215# exported function: cabal-style copy and register 460# exported function: cabal-style copy and register
216cabal_src_install() { 461cabal_src_install() {
462 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
463
464 if cabal-is-dummy-lib; then
465 # create a dummy local package conf file for the sake of ghc-updater
466 local ghc_confdir_with_prefix="$(ghc-confdir)"
467 # remove EPREFIX
468 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
469 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
470 else
217 cabal-copy 471 cabal-copy
218 cabal-pkg 472 cabal-pkg
219 473
220 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 474 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
475 if ! version_is_at_least "1.1.6" "$(cabal-version)"; then
221 dohtml dist/doc/html/* 476 dohtml -r dist/doc/html/*
477 fi
222 fi 478 fi
479 fi
223} 480}
481
224haskell-cabal_src_install() { 482haskell-cabal_src_install() {
483 pushd "${S}" > /dev/null
484
225 cabal_src_install 485 cabal_src_install
226}
227 486
228EXPORT_FUNCTIONS pkg_setup src_compile src_install 487 popd > /dev/null
488}
489
490# ebuild.sh:use_enable() taken as base
491#
492# Usage examples:
493#
494# CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
495# leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
496#
497# CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
498# also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
499#
500cabal_flag() {
501 if [[ -z "$1" ]]; then
502 echo "!!! cabal_flag() called without a parameter." >&2
503 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
504 return 1
505 fi
506
507 local UWORD=${2:-$1}
508
509 if use "$1"; then
510 echo "--flags=${UWORD}"
511 else
512 echo "--flags=-${UWORD}"
513 fi
514
515 return 0
516}

Legend:
Removed from v.1.5  
changed lines
  Added in v.1.24

  ViewVC Help
Powered by ViewVC 1.1.20